/*
Copyright 2021 Loft Labs Inc.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// Code generated by client-gen. DO NOT EDIT.

package fake

import (
	"context"

	v1beta1 "github.com/loft-sh/jspolicy/pkg/apis/policy/v1beta1"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	labels "k8s.io/apimachinery/pkg/labels"
	schema "k8s.io/apimachinery/pkg/runtime/schema"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	testing "k8s.io/client-go/testing"
)

// FakeJsPolicies implements JsPolicyInterface
type FakeJsPolicies struct {
	Fake *FakePolicyV1beta1
}

var jspoliciesResource = schema.GroupVersionResource{Group: "policy.jspolicy.com", Version: "v1beta1", Resource: "jspolicies"}

var jspoliciesKind = schema.GroupVersionKind{Group: "policy.jspolicy.com", Version: "v1beta1", Kind: "JsPolicy"}

// Get takes name of the jsPolicy, and returns the corresponding jsPolicy object, and an error if there is any.
func (c *FakeJsPolicies) Get(ctx context.Context, name string, options v1.GetOptions) (result *v1beta1.JsPolicy, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootGetAction(jspoliciesResource, name), &v1beta1.JsPolicy{})
	if obj == nil {
		return nil, err
	}
	return obj.(*v1beta1.JsPolicy), err
}

// List takes label and field selectors, and returns the list of JsPolicies that match those selectors.
func (c *FakeJsPolicies) List(ctx context.Context, opts v1.ListOptions) (result *v1beta1.JsPolicyList, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootListAction(jspoliciesResource, jspoliciesKind, opts), &v1beta1.JsPolicyList{})
	if obj == nil {
		return nil, err
	}

	label, _, _ := testing.ExtractFromListOptions(opts)
	if label == nil {
		label = labels.Everything()
	}
	list := &v1beta1.JsPolicyList{ListMeta: obj.(*v1beta1.JsPolicyList).ListMeta}
	for _, item := range obj.(*v1beta1.JsPolicyList).Items {
		if label.Matches(labels.Set(item.Labels)) {
			list.Items = append(list.Items, item)
		}
	}
	return list, err
}

// Watch returns a watch.Interface that watches the requested jsPolicies.
func (c *FakeJsPolicies) Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error) {
	return c.Fake.
		InvokesWatch(testing.NewRootWatchAction(jspoliciesResource, opts))
}

// Create takes the representation of a jsPolicy and creates it.  Returns the server's representation of the jsPolicy, and an error, if there is any.
func (c *FakeJsPolicies) Create(ctx context.Context, jsPolicy *v1beta1.JsPolicy, opts v1.CreateOptions) (result *v1beta1.JsPolicy, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootCreateAction(jspoliciesResource, jsPolicy), &v1beta1.JsPolicy{})
	if obj == nil {
		return nil, err
	}
	return obj.(*v1beta1.JsPolicy), err
}

// Update takes the representation of a jsPolicy and updates it. Returns the server's representation of the jsPolicy, and an error, if there is any.
func (c *FakeJsPolicies) Update(ctx context.Context, jsPolicy *v1beta1.JsPolicy, opts v1.UpdateOptions) (result *v1beta1.JsPolicy, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootUpdateAction(jspoliciesResource, jsPolicy), &v1beta1.JsPolicy{})
	if obj == nil {
		return nil, err
	}
	return obj.(*v1beta1.JsPolicy), err
}

// UpdateStatus was generated because the type contains a Status member.
// Add a +genclient:noStatus comment above the type to avoid generating UpdateStatus().
func (c *FakeJsPolicies) UpdateStatus(ctx context.Context, jsPolicy *v1beta1.JsPolicy, opts v1.UpdateOptions) (*v1beta1.JsPolicy, error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootUpdateSubresourceAction(jspoliciesResource, "status", jsPolicy), &v1beta1.JsPolicy{})
	if obj == nil {
		return nil, err
	}
	return obj.(*v1beta1.JsPolicy), err
}

// Delete takes name of the jsPolicy and deletes it. Returns an error if one occurs.
func (c *FakeJsPolicies) Delete(ctx context.Context, name string, opts v1.DeleteOptions) error {
	_, err := c.Fake.
		Invokes(testing.NewRootDeleteAction(jspoliciesResource, name), &v1beta1.JsPolicy{})
	return err
}

// DeleteCollection deletes a collection of objects.
func (c *FakeJsPolicies) DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error {
	action := testing.NewRootDeleteCollectionAction(jspoliciesResource, listOpts)

	_, err := c.Fake.Invokes(action, &v1beta1.JsPolicyList{})
	return err
}

// Patch applies the patch and returns the patched jsPolicy.
func (c *FakeJsPolicies) Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *v1beta1.JsPolicy, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootPatchSubresourceAction(jspoliciesResource, name, pt, data, subresources...), &v1beta1.JsPolicy{})
	if obj == nil {
		return nil, err
	}
	return obj.(*v1beta1.JsPolicy), err
}
