/*
Copyright 2021 Loft Labs Inc.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// Code generated by client-gen. DO NOT EDIT.

package v1beta1

import (
	"context"
	"time"

	v1beta1 "github.com/loft-sh/jspolicy/pkg/apis/policy/v1beta1"
	scheme "github.com/loft-sh/jspolicy/pkg/client/clientset_generated/clientset/scheme"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	rest "k8s.io/client-go/rest"
)

// JsPolicyBundlesGetter has a method to return a JsPolicyBundleInterface.
// A group's client should implement this interface.
type JsPolicyBundlesGetter interface {
	JsPolicyBundles() JsPolicyBundleInterface
}

// JsPolicyBundleInterface has methods to work with JsPolicyBundle resources.
type JsPolicyBundleInterface interface {
	Create(ctx context.Context, jsPolicyBundle *v1beta1.JsPolicyBundle, opts v1.CreateOptions) (*v1beta1.JsPolicyBundle, error)
	Update(ctx context.Context, jsPolicyBundle *v1beta1.JsPolicyBundle, opts v1.UpdateOptions) (*v1beta1.JsPolicyBundle, error)
	UpdateStatus(ctx context.Context, jsPolicyBundle *v1beta1.JsPolicyBundle, opts v1.UpdateOptions) (*v1beta1.JsPolicyBundle, error)
	Delete(ctx context.Context, name string, opts v1.DeleteOptions) error
	DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error
	Get(ctx context.Context, name string, opts v1.GetOptions) (*v1beta1.JsPolicyBundle, error)
	List(ctx context.Context, opts v1.ListOptions) (*v1beta1.JsPolicyBundleList, error)
	Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error)
	Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *v1beta1.JsPolicyBundle, err error)
	JsPolicyBundleExpansion
}

// jsPolicyBundles implements JsPolicyBundleInterface
type jsPolicyBundles struct {
	client rest.Interface
}

// newJsPolicyBundles returns a JsPolicyBundles
func newJsPolicyBundles(c *PolicyV1beta1Client) *jsPolicyBundles {
	return &jsPolicyBundles{
		client: c.RESTClient(),
	}
}

// Get takes name of the jsPolicyBundle, and returns the corresponding jsPolicyBundle object, and an error if there is any.
func (c *jsPolicyBundles) Get(ctx context.Context, name string, options v1.GetOptions) (result *v1beta1.JsPolicyBundle, err error) {
	result = &v1beta1.JsPolicyBundle{}
	err = c.client.Get().
		Resource("jspolicybundles").
		Name(name).
		VersionedParams(&options, scheme.ParameterCodec).
		Do(ctx).
		Into(result)
	return
}

// List takes label and field selectors, and returns the list of JsPolicyBundles that match those selectors.
func (c *jsPolicyBundles) List(ctx context.Context, opts v1.ListOptions) (result *v1beta1.JsPolicyBundleList, err error) {
	var timeout time.Duration
	if opts.TimeoutSeconds != nil {
		timeout = time.Duration(*opts.TimeoutSeconds) * time.Second
	}
	result = &v1beta1.JsPolicyBundleList{}
	err = c.client.Get().
		Resource("jspolicybundles").
		VersionedParams(&opts, scheme.ParameterCodec).
		Timeout(timeout).
		Do(ctx).
		Into(result)
	return
}

// Watch returns a watch.Interface that watches the requested jsPolicyBundles.
func (c *jsPolicyBundles) Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error) {
	var timeout time.Duration
	if opts.TimeoutSeconds != nil {
		timeout = time.Duration(*opts.TimeoutSeconds) * time.Second
	}
	opts.Watch = true
	return c.client.Get().
		Resource("jspolicybundles").
		VersionedParams(&opts, scheme.ParameterCodec).
		Timeout(timeout).
		Watch(ctx)
}

// Create takes the representation of a jsPolicyBundle and creates it.  Returns the server's representation of the jsPolicyBundle, and an error, if there is any.
func (c *jsPolicyBundles) Create(ctx context.Context, jsPolicyBundle *v1beta1.JsPolicyBundle, opts v1.CreateOptions) (result *v1beta1.JsPolicyBundle, err error) {
	result = &v1beta1.JsPolicyBundle{}
	err = c.client.Post().
		Resource("jspolicybundles").
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(jsPolicyBundle).
		Do(ctx).
		Into(result)
	return
}

// Update takes the representation of a jsPolicyBundle and updates it. Returns the server's representation of the jsPolicyBundle, and an error, if there is any.
func (c *jsPolicyBundles) Update(ctx context.Context, jsPolicyBundle *v1beta1.JsPolicyBundle, opts v1.UpdateOptions) (result *v1beta1.JsPolicyBundle, err error) {
	result = &v1beta1.JsPolicyBundle{}
	err = c.client.Put().
		Resource("jspolicybundles").
		Name(jsPolicyBundle.Name).
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(jsPolicyBundle).
		Do(ctx).
		Into(result)
	return
}

// UpdateStatus was generated because the type contains a Status member.
// Add a +genclient:noStatus comment above the type to avoid generating UpdateStatus().
func (c *jsPolicyBundles) UpdateStatus(ctx context.Context, jsPolicyBundle *v1beta1.JsPolicyBundle, opts v1.UpdateOptions) (result *v1beta1.JsPolicyBundle, err error) {
	result = &v1beta1.JsPolicyBundle{}
	err = c.client.Put().
		Resource("jspolicybundles").
		Name(jsPolicyBundle.Name).
		SubResource("status").
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(jsPolicyBundle).
		Do(ctx).
		Into(result)
	return
}

// Delete takes name of the jsPolicyBundle and deletes it. Returns an error if one occurs.
func (c *jsPolicyBundles) Delete(ctx context.Context, name string, opts v1.DeleteOptions) error {
	return c.client.Delete().
		Resource("jspolicybundles").
		Name(name).
		Body(&opts).
		Do(ctx).
		Error()
}

// DeleteCollection deletes a collection of objects.
func (c *jsPolicyBundles) DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error {
	var timeout time.Duration
	if listOpts.TimeoutSeconds != nil {
		timeout = time.Duration(*listOpts.TimeoutSeconds) * time.Second
	}
	return c.client.Delete().
		Resource("jspolicybundles").
		VersionedParams(&listOpts, scheme.ParameterCodec).
		Timeout(timeout).
		Body(&opts).
		Do(ctx).
		Error()
}

// Patch applies the patch and returns the patched jsPolicyBundle.
func (c *jsPolicyBundles) Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *v1beta1.JsPolicyBundle, err error) {
	result = &v1beta1.JsPolicyBundle{}
	err = c.client.Patch(pt).
		Resource("jspolicybundles").
		Name(name).
		SubResource(subresources...).
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(data).
		Do(ctx).
		Into(result)
	return
}
