/*
Copyright 2021 Loft Labs Inc.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// Code generated by client-gen. DO NOT EDIT.

package v1beta1

import (
	"context"
	"time"

	v1beta1 "github.com/loft-sh/jspolicy/pkg/apis/policy/v1beta1"
	scheme "github.com/loft-sh/jspolicy/pkg/client/clientset_generated/clientset/scheme"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	rest "k8s.io/client-go/rest"
)

// JsPolicyViolationsesGetter has a method to return a JsPolicyViolationsInterface.
// A group's client should implement this interface.
type JsPolicyViolationsesGetter interface {
	JsPolicyViolationses() JsPolicyViolationsInterface
}

// JsPolicyViolationsInterface has methods to work with JsPolicyViolations resources.
type JsPolicyViolationsInterface interface {
	Create(ctx context.Context, jsPolicyViolations *v1beta1.JsPolicyViolations, opts v1.CreateOptions) (*v1beta1.JsPolicyViolations, error)
	Update(ctx context.Context, jsPolicyViolations *v1beta1.JsPolicyViolations, opts v1.UpdateOptions) (*v1beta1.JsPolicyViolations, error)
	UpdateStatus(ctx context.Context, jsPolicyViolations *v1beta1.JsPolicyViolations, opts v1.UpdateOptions) (*v1beta1.JsPolicyViolations, error)
	Delete(ctx context.Context, name string, opts v1.DeleteOptions) error
	DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error
	Get(ctx context.Context, name string, opts v1.GetOptions) (*v1beta1.JsPolicyViolations, error)
	List(ctx context.Context, opts v1.ListOptions) (*v1beta1.JsPolicyViolationsList, error)
	Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error)
	Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *v1beta1.JsPolicyViolations, err error)
	JsPolicyViolationsExpansion
}

// jsPolicyViolationses implements JsPolicyViolationsInterface
type jsPolicyViolationses struct {
	client rest.Interface
}

// newJsPolicyViolationses returns a JsPolicyViolationses
func newJsPolicyViolationses(c *PolicyV1beta1Client) *jsPolicyViolationses {
	return &jsPolicyViolationses{
		client: c.RESTClient(),
	}
}

// Get takes name of the jsPolicyViolations, and returns the corresponding jsPolicyViolations object, and an error if there is any.
func (c *jsPolicyViolationses) Get(ctx context.Context, name string, options v1.GetOptions) (result *v1beta1.JsPolicyViolations, err error) {
	result = &v1beta1.JsPolicyViolations{}
	err = c.client.Get().
		Resource("jspolicyviolationses").
		Name(name).
		VersionedParams(&options, scheme.ParameterCodec).
		Do(ctx).
		Into(result)
	return
}

// List takes label and field selectors, and returns the list of JsPolicyViolationses that match those selectors.
func (c *jsPolicyViolationses) List(ctx context.Context, opts v1.ListOptions) (result *v1beta1.JsPolicyViolationsList, err error) {
	var timeout time.Duration
	if opts.TimeoutSeconds != nil {
		timeout = time.Duration(*opts.TimeoutSeconds) * time.Second
	}
	result = &v1beta1.JsPolicyViolationsList{}
	err = c.client.Get().
		Resource("jspolicyviolationses").
		VersionedParams(&opts, scheme.ParameterCodec).
		Timeout(timeout).
		Do(ctx).
		Into(result)
	return
}

// Watch returns a watch.Interface that watches the requested jsPolicyViolationses.
func (c *jsPolicyViolationses) Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error) {
	var timeout time.Duration
	if opts.TimeoutSeconds != nil {
		timeout = time.Duration(*opts.TimeoutSeconds) * time.Second
	}
	opts.Watch = true
	return c.client.Get().
		Resource("jspolicyviolationses").
		VersionedParams(&opts, scheme.ParameterCodec).
		Timeout(timeout).
		Watch(ctx)
}

// Create takes the representation of a jsPolicyViolations and creates it.  Returns the server's representation of the jsPolicyViolations, and an error, if there is any.
func (c *jsPolicyViolationses) Create(ctx context.Context, jsPolicyViolations *v1beta1.JsPolicyViolations, opts v1.CreateOptions) (result *v1beta1.JsPolicyViolations, err error) {
	result = &v1beta1.JsPolicyViolations{}
	err = c.client.Post().
		Resource("jspolicyviolationses").
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(jsPolicyViolations).
		Do(ctx).
		Into(result)
	return
}

// Update takes the representation of a jsPolicyViolations and updates it. Returns the server's representation of the jsPolicyViolations, and an error, if there is any.
func (c *jsPolicyViolationses) Update(ctx context.Context, jsPolicyViolations *v1beta1.JsPolicyViolations, opts v1.UpdateOptions) (result *v1beta1.JsPolicyViolations, err error) {
	result = &v1beta1.JsPolicyViolations{}
	err = c.client.Put().
		Resource("jspolicyviolationses").
		Name(jsPolicyViolations.Name).
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(jsPolicyViolations).
		Do(ctx).
		Into(result)
	return
}

// UpdateStatus was generated because the type contains a Status member.
// Add a +genclient:noStatus comment above the type to avoid generating UpdateStatus().
func (c *jsPolicyViolationses) UpdateStatus(ctx context.Context, jsPolicyViolations *v1beta1.JsPolicyViolations, opts v1.UpdateOptions) (result *v1beta1.JsPolicyViolations, err error) {
	result = &v1beta1.JsPolicyViolations{}
	err = c.client.Put().
		Resource("jspolicyviolationses").
		Name(jsPolicyViolations.Name).
		SubResource("status").
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(jsPolicyViolations).
		Do(ctx).
		Into(result)
	return
}

// Delete takes name of the jsPolicyViolations and deletes it. Returns an error if one occurs.
func (c *jsPolicyViolationses) Delete(ctx context.Context, name string, opts v1.DeleteOptions) error {
	return c.client.Delete().
		Resource("jspolicyviolationses").
		Name(name).
		Body(&opts).
		Do(ctx).
		Error()
}

// DeleteCollection deletes a collection of objects.
func (c *jsPolicyViolationses) DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error {
	var timeout time.Duration
	if listOpts.TimeoutSeconds != nil {
		timeout = time.Duration(*listOpts.TimeoutSeconds) * time.Second
	}
	return c.client.Delete().
		Resource("jspolicyviolationses").
		VersionedParams(&listOpts, scheme.ParameterCodec).
		Timeout(timeout).
		Body(&opts).
		Do(ctx).
		Error()
}

// Patch applies the patch and returns the patched jsPolicyViolations.
func (c *jsPolicyViolationses) Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *v1beta1.JsPolicyViolations, err error) {
	result = &v1beta1.JsPolicyViolations{}
	err = c.client.Patch(pt).
		Resource("jspolicyviolationses").
		Name(name).
		SubResource(subresources...).
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(data).
		Do(ctx).
		Into(result)
	return
}
